{% set arch = cuda.arch %}
{# {% if arch != "x86_64" %} #}
{# # NOTICE: requires experimental features to be enabled on the docker daemon #}
{# FROM --platform={{ arch }} {{ cuda.base_image }} #}
{# {% else %} #}
FROM {{ cuda.base_image }}
{# {% endif %} #}

LABEL maintainer "NVIDIA CORPORATION <sw-cuda-installer@nvidia.com>"

RUN NVIDIA_GPGKEY_SUM=d1be581509378368edeec8c1eb2958702feedf3bc3d17011adbf24efacce4ab5 && \
    curl -fsSL {{ cuda.repo_url }}/7fa2af80.pub | sed '/^Version/d' > /etc/pki/rpm-gpg/RPM-GPG-KEY-NVIDIA && \
    echo "$NVIDIA_GPGKEY_SUM  /etc/pki/rpm-gpg/RPM-GPG-KEY-NVIDIA" | sha256sum -c {% if cuda.os.version | int != 6 %}--strict {% endif %} -

COPY cuda.repo /etc/yum.repos.d/cuda.repo
{% if "use_ml_repo" in cuda and cuda.use_ml_repo %}
COPY nvidia-ml.repo /etc/yum.repos.d/nvidia-ml.repo
{% endif %}

ENV CUDA_VERSION {{ cuda.version.release_label }}
{% if cuda.version.major | int != 11 %}
ENV CUDA_PKG_VERSION {{ cuda.version.major }}-{{ cuda.version.minor }}-$CUDA_VERSION-1
{% endif %}

{%- if "cudart" in cuda.components %}
{% set cudart_component_version = cuda.version.major + "-" + cuda.version.minor + "-" + cuda.components.cudart.version %}
{% endif %}

# For libraries in the cuda-compat-* package: https://docs.nvidia.com/cuda/eula/index.html#attachment-a
RUN yum upgrade -y && yum install -y \
{% if cuda.version.major | int == 8 %}
    cuda-nvrtc-$CUDA_PKG_VERSION \
    cuda-nvgraph-$CUDA_PKG_VERSION \
    cuda-cusolver-$CUDA_PKG_VERSION \
    cuda-cublas-{{ cuda.version.major }}-{{ cuda.version.minor }}-{{ cuda.version.release_label }}.2-1 \
    cuda-cufft-$CUDA_PKG_VERSION \
    cuda-curand-$CUDA_PKG_VERSION \
    cuda-cusparse-$CUDA_PKG_VERSION \
    cuda-npp-$CUDA_PKG_VERSION \
    cuda-cudart-$CUDA_PKG_VERSION \
{% else %}
    cuda-cudart-{{ cudart_component_version if cuda.version.major | int == 11 else "$CUDA_PKG_VERSION" }} \
{% endif %}
{% if cuda.version.major | int >= 10 %}
    cuda-compat-{{ cuda.version.major }}-{{ cuda.version.minor }} \
{% endif %}
    && ln -s cuda-{{ cuda.version.major }}.{{ cuda.version.minor }} /usr/local/cuda \
    && yum clean all \
    && rm -rf /var/cache/yum/*

# nvidia-docker 1.0
{% if cuda.version.major | int == 8 or cuda.version.major | int == 9 -%}
LABEL com.nvidia.volumes.needed="nvidia_driver"
LABEL com.nvidia.cuda.version="${CUDA_VERSION}"
{% endif %}
RUN echo "/usr/local/nvidia/lib" >> /etc/ld.so.conf.d/nvidia.conf && \
    echo "/usr/local/nvidia/lib64" >> /etc/ld.so.conf.d/nvidia.conf

ENV PATH /usr/local/nvidia/bin:/usr/local/cuda/bin:${PATH}
ENV LD_LIBRARY_PATH /usr/local/nvidia/lib:/usr/local/nvidia/lib64

COPY NGC-DL-CONTAINER-LICENSE /

# nvidia-container-runtime
ENV NVIDIA_VISIBLE_DEVICES all
ENV NVIDIA_DRIVER_CAPABILITIES compute,utility
{% if "requires" in cuda %}
ENV NVIDIA_REQUIRE_CUDA "{{ cuda.requires }}"
{% endif %}
